' ************************************
' *** ***
' *** Reaktiv-Tiny v0.1 24/11/2005 ***
' *** ***
' ************************************

$regfile = "ATtiny13.DAT"
$crystal = 113000                                           'Reale Frequenz des internen 128kHz-Oszillators

Config Portb = &B00011000                                   'Pinb.3 und .4 auf 'Ausgang', Rest auf 'Eingang' schalten
Portb = &B11100111                                          'Pullups zuschalten, auer fr Pinb.3 und .4
Stop Adc                                                    'A/D-Wandler abschalten, um Strom zu sparen
Stop Ac                                                     'Analog-Komparator abschalten, um Strom zu sparen

Dim A As Byte
Dim B As Byte
Dim Led_ladezustand As Bit
Dim Hell As Bit

Do
 Gosub Led_abfrage

 If Led_ladezustand = 0 Then
  Hell = 1                                                  'Bei Licht Merker setzen
 End If
 If Hell = 1 And B < 255 Then
  B = B + 1                                                 'Wenn Merker gesetzt wurde, Zhler fr Licht dauer erhhen (max. 255)
 End If
 If Led_ladezustand = 1 And Hell = 1 And B < 50 Then
   Gosub Blinken                                            'Wenn es wieder dunkel ist und der Lichtimpuls nur kurz war, dann blinken
 End If
 If Led_ladezustand = 1 Then                                'Bei Dunkelheit Merker und Zhler fr Lichtdauer
  Hell = 0                                                  'lschen
  B = 0
 End If
Loop

Led_abfrage:
 Portb.3 = 0                                                'Portb.3 auf Masse schalten
 Portb.4 = 1                                                'Portb.4 auf +Ub schalten, um die LED zu 'laden'
 Waitus 1                                                   'Ladezeit, kann ggf. noch verkleinert werden
 Config Portb.4 = Input                                     'Portb.4 nun zwecks Abfrage der LED-Ladung auf 'Eingang schalten
 Portb.4 = 0                                                'Pullup abschalten, sonst geht's nicht!
 Waitms 20                                                  'Entladezeit 20 ms - je kleiner, je unempfindlicher
 Led_ladezustand = Pinb.4                                   'Ladezustand einlesen: '1' -> dunkel, '0' -> hell
 Config Portb.4 = Output                                    'Portb.4 wieder auf Ausgang schalten
 Portb.4 = 0                                                'Portb.4 auf Masse schalten
Return

Blinken:
 For A = 1 To 10
  Portb.3 = 1
  Waitms 50
  Portb.3 = 0
  Waitms 500
 Next A
Return

End